<?php
class Tree extends Ulyxex {
	function __construct() {
		$this->h = New Html();
		$this->tr = New Translate();
		$this->motherIdOf = array();
		$this->name = array();
	}
	public function paths($hide=Null) {
		$paths = array();
		if ($hide) {
			$query = "SELECT ID,NAME,PARENTID FROM ".PAGES." WHERE HIDE != 1";
		} else {
			$query = "SELECT ID,NAME,PARENTID FROM ".PAGES;
		}
		
		$query = $this->q($query);
		
		while ( $line = $this->fetch($query) ) {
			$this->motherIdOf[$line['ID']] = $line['PARENTID'];
			$this->name[$line['ID']] = $line['NAME'];
		}

		foreach($this->motherIdOf as $daughter => $mother) {
			$ancestorId = 0;
			$ancestorsNames = array();
			if ($mother == 0) {
				// if mother is home
				$lineage = "/".$this->name[$daughter]."/";
				$paths[$lineage] = $daughter; 
			} else {
				// if mother other than home exist
				// add mother
				if (isset($this->name[$mother])) {
					// check if error in lineage
					if ( in_array($this->name[$mother],$ancestorsNames) ) {print " error tree !";break;}
					$ancestorsNames[] = $this->name[$mother];
				}
				// if a gran mother exist
				if (array_key_exists($mother, $this->motherIdOf)) { 
					$ancestorId = $this->motherIdOf[$mother];
					// if others gran gran... mother exist
					while ($ancestorId != 0) {
						if (isset($this->name[$ancestorId])) {
							// check if error in lineage
							if ( in_array($this->name[$ancestorId],$ancestorsNames) ) {print " error tree !";break;}
							$ancestorsNames[] = $this->name[$ancestorId];
						}
						
						if (isset($this->motherIdOf[$ancestorId]) && $this->motherIdOf[$ancestorId] != 0) { 
							$ancestorId = $this->motherIdOf[$ancestorId];
						} else {
							$ancestorId = 0;
						}
					}
					$ancestorsNames = array_reverse($ancestorsNames);
					$lineage = "/".implode("/",$ancestorsNames)."/".$this->name[$daughter]."/";
					$paths[$lineage] = $daughter; 
				}
				
			}
		}
		// $_ = array();
		// foreach($paths as $k=>$v) {
			// $_[$this->h->strWidth($k,50)] = $v;
		// }
		// $paths = $_;
		return $paths;
	}
	public function pathsSelect($selected=Null,$root=1) {
		$paths = $this->paths();
		ksort($paths);
		$elements = array();
		if ($root) $elements["ROOT/"] = 0;
		foreach($paths as $path => $idVal) {
			$pathLevels = explode("/",$path);
			$path = "ROOT-";
			$path .= str_repeat("-",count($pathLevels)-3); // 3 for first "/", last "/" and array position
			array_pop($pathLevels);
			$path .= ">".array_pop($pathLevels);
			$elements[$path.$this->h->comments($idVal)] = $idVal;
		}
		$result = $this->h->select($elements,"parent",$selected);
		return $result;
	}
	public function pathsTest($page=0,$parent=0) {
		$paths = $this->paths();
		$lineage = explode("/",array_search($parent,$paths));
		$result = (in_array($this->name[$page],$lineage))?0:1;
		return $result;
	}
	public function pathPage($parent=0) {
		$paths = $this->paths();
		return array_search($parent,$paths);
	}
	public function pagesNavigation($page=Null) {
		$paths = $this->paths($hide=1);
		ksort($paths);
		$pages_paths = array();
		$selectedPath = $page;
		$navigationTitle = "--".$this->tr->w("Pages").str_repeat("-",20-strlen($this->tr->w("Pages")));
		$linksTitle = "--".$this->tr->w("Links").str_repeat("-",20-strlen($this->tr->w("Links")));
		// pages
		$pages_paths[$navigationTitle] = "limit";
		foreach($paths as $path => $idVal) {
			$pathLevels = explode("/",$path);
			$path = str_repeat("-",count($pathLevels)-3); // 3 for first "/", last "/" and array position
			if (count($pathLevels)-3 > 0) $path .= "> ";
			array_pop($pathLevels);
			$path .= array_pop($pathLevels);
			$pages_paths[$path.$this->h->comments($idVal)] = $idVal;
		}
		
		// links
		$query = "SELECT "."ID,NAME FROM ".LINKS." WHERE HIDE != 1 ORDER BY NAME";
		$query = $this->q($query);
		$link_paths = array();
		$separation = 1;
		while ( $line = $this->fetch($query) ) {
				if ($separation) {
					$link_paths[$linksTitle] = "limit";
				$separation = 0;
			}
			$link_paths["- ".$line['NAME']] = "link".$line['ID'];
		}
		$elements = array_merge($pages_paths,$link_paths);
		$menu = $this->h->input("hidden","k","page").$this->h->select($elements,"v",$selectedPath)." ".$this->h->input("submit",null,"GO");
		$result = $this->h->form($menu,"navform","post","index.php");
		return $result;
	}
}  
?>